#Copyright 2000 Paul D. Fernhouit
#Reuse permitted under X11 type License

#code is proof of concept level


print "hello world"

from wxPython.wx import *
from wxPython.lib.editor import wxEditor, wxPyEditor
  
#---------------------------------------------------------------------------
#not currently used

class TestListBox(wxPanel):
    def __init__(self, parent, log):
        self.log = log
        wxPanel.__init__(self, parent, -1)

        sampleList = ['zero', 'one', 'two', 'three', 'four', 'five',
                      'six', 'seven', 'eight', 'nine', 'ten', 'eleven',
                      'twelve', 'thirteen', 'fourteen']

        wxStaticText(self, -1, "This example uses the wxListBox control.",
                               wxPoint(45, 10))

        wxStaticText(self, -1, "Select one:", wxPoint(15, 50), wxSize(65, 18))
        self.lb1 = wxListBox(self, 60, wxPoint(80, 50), wxSize(80, 120),
                       sampleList, wxLB_SINGLE)
        EVT_LISTBOX(self, 60, self.EvtListBox)
        EVT_LISTBOX_DCLICK(self, 60, self.EvtListBoxDClick)
        EVT_RIGHT_UP(self.lb1, self.EvtRightButton)
        self.lb1.SetSelection(0)

    def EvtListBox(self, event):
        self.log.WriteText('EvtListBox: %s\n' % event.GetString())

    def EvtListBoxDClick(self, event):
        self.log.WriteText('EvtListBoxDClick: %s\n' % self.lb1.GetSelection())
        self.lb1.Delete(self.lb1.GetSelection())

    def EvtMultiListBox(self, event):
        self.log.WriteText('EvtMultiListBox: %s\n' % str(self.lb2.GetSelections()))

    def EvtRightButton(self, event):
        self.log.WriteText('EvtRightButton: %s\n' % event.GetPosition())


#---------------------------------------------------------------------------

class MyEditor(wxPanel):
    def __init__(self, parent):
        wxPanel.__init__(self, parent, -1)
        self.textEditor =  wxTextCtrl(self, 30, "", wxPoint(0, 0), wxSize(300, 150), wxTE_MULTILINE)

    def OnSize(self, event):
        w,h = self.GetClientSizeTuple()
        self.textEditor.SetDimensions(0, 0, w, h)
        
#-----------------------------------------------------------
import sys, os
from wxPython.lib.mvctree import *


logger = None
topFrame = None

class MyLogger:
    def write(self, message):
        print message
        
    def WriteText(self, message):
        print message
        
logger = MyLogger()

def selchanging(evt):
    #logger.write("SelChanging!\n")
    pass

def selchanged(evt):
    logger.write("SelChange!\n")
    logger.write(str(evt.node))
    #print evt
    #print evt.node
    topFrame.viewer.html.SetPage(str(evt.node))
    
def expanded(evt):
    logger.write("Expanded\n")
def closed(evt):
    logger.write("Closed!\n")
def key(evt):
    logger.write("Key\n")
def add(evt):
    logger.write("Add\n")
def delitem(evt):
    logger.write("Delete\n")

def BuildTreeWidget(parent):
    #f = wxFrame(frame, -1, "wxMVCTree", wxPoint(0,0), wxSize(200,500))
    p = wxMVCTree(parent, -1)
    #f = wxFrame(frame, -1, "wxMVCTree")
    #p = wxMVCTree(f, -1)
    p.SetAssumeChildren(true)
    p.SetModel(LateFSTreeModel(os.path.normpath(os.getcwd() + os.sep +'..')))
    #Uncomment this to enable live filename editing!
#    p.AddEditor(FileEditor(p))
    p.SetMultiSelect(true)
    EVT_MVCTREE_SEL_CHANGING(p, p.GetId(), selchanging)
    EVT_MVCTREE_SEL_CHANGED(p, p.GetId(), selchanged)
    EVT_MVCTREE_ITEM_EXPANDED(p, p.GetId(), expanded)
    EVT_MVCTREE_ITEM_COLLAPSED(p, p.GetId(), closed)
    EVT_MVCTREE_ADD_ITEM(p, p.GetId(), add)
    EVT_MVCTREE_DELETE_ITEM(p, p.GetId(), delitem)
    EVT_MVCTREE_KEY_DOWN(p, p.GetId(), key)
    return p
    

#----------------------------------------------------------------------
from   wxPython.html       import *
import wxPython.lib.wxpTag

# This shows how to catch the OnLinkClicked non-event.  (It's a virtual
# method in the C++ code...)
class MyHtmlWindow(wxHtmlWindow):
    def __init__(self, parent, id):
        wxHtmlWindow.__init__(self, parent, id)
        self.log = logger

    def OnLinkClicked(self, linkinfo):
        self.log.WriteText('OnLinkClicked: %s\n' % linkinfo.GetHref())

        # Virtuals in the base class have been renamed with base_ on the front.
        self.base_OnLinkClicked(linkinfo)

    def OnSetTitle(self, title):
        self.log.WriteText('OnSetTitle: %s\n' % title)
        self.base_OnSetTitle(title)

    def __del__(self):
        print 'MyHtmlWindow.__del__'


class TestHtmlPanel(wxPanel):
    def __init__(self, parent, frame):
        wxPanel.__init__(self, parent, -1)
        self.log = logger
        self.frame = frame
        self.cwd = os.path.split(sys.argv[0])[0]
        if not self.cwd:
            self.cwd = os.getcwd()

        self.html = MyHtmlWindow(self, -1)
        self.html.SetRelatedFrame(frame, "wxPython: (A Demonstration) -- %s")
        self.html.SetRelatedStatusBar(0)

        self.printer = wxHtmlEasyPrinting()

        self.box = wxBoxSizer(wxVERTICAL)
        self.box.Add(self.html, 1, wxGROW)

        subbox = wxBoxSizer(wxHORIZONTAL)
        btn = wxButton(self, 1201, "Show Default")
        EVT_BUTTON(self, 1201, self.OnShowDefault)
        subbox.Add(btn, 1, wxGROW | wxALL, 2)

        btn = wxButton(self, 1202, "Load File")
        EVT_BUTTON(self, 1202, self.OnLoadFile)
        subbox.Add(btn, 1, wxGROW | wxALL, 2)

        #btn = wxButton(self, 1203, "With Widgets")
        #EVT_BUTTON(self, 1203, self.OnWithWidgets)
        #subbox.Add(btn, 1, wxGROW | wxALL, 2)

        btn = wxButton(self, 1204, "Back")
        EVT_BUTTON(self, 1204, self.OnBack)
        subbox.Add(btn, 1, wxGROW | wxALL, 2)

        btn = wxButton(self, 1205, "Forward")
        EVT_BUTTON(self, 1205, self.OnForward)
        subbox.Add(btn, 1, wxGROW | wxALL, 2)

        btn = wxButton(self, 1207, "Print")
        EVT_BUTTON(self, 1207, self.OnPrint)
        subbox.Add(btn, 1, wxGROW | wxALL, 2)

        btn = wxButton(self, 1206, "View Source")
        EVT_BUTTON(self, 1206, self.OnViewSource)
        subbox.Add(btn, 1, wxGROW | wxALL, 2)

        self.box.Add(subbox, 0, wxGROW)
        self.SetSizer(self.box)
        self.SetAutoLayout(true)

        # A button with this ID is created on the widget test page.
        EVT_BUTTON(self, wxID_OK, self.OnOk)

        self.OnShowDefault(None)


    def __del__(self):
        print 'TestHtmlPanel.__del__'


    def OnShowDefault(self, event):
        name = os.path.join(self.cwd, 'default.htm')
        self.html.LoadPage(name)


    def OnLoadFile(self, event):
        dlg = wxFileDialog(self, wildcard = '*.htm*', style=wxOPEN)
        if dlg.ShowModal():
            path = dlg.GetPath()
            self.html.LoadPage(path)
        dlg.Destroy()


    def OnWithWidgets(self, event):
        os.chdir(self.cwd)
        name = os.path.join(self.cwd, 'data/widgetTest.htm')
        self.html.LoadPage(name)


    def OnOk(self, event):
        self.log.WriteText("It works!\n")

    def OnBack(self, event):
        if not self.html.HistoryBack():
            wxMessageBox("No more items in history!")


    def OnForward(self, event):
        if not self.html.HistoryForward():
            wxMessageBox("No more items in history!")


    def OnViewSource(self, event):
        #from wxPython.lib.dialogs import wxScrolledMessageDialog
        source = self.html.GetParser().GetSource()
        #dlg = wxScrolledMessageDialog(self, source, 'HTML Source')
        #dlg.ShowModal()
        #dlg.Destroy()
        self.frame.editor.textEditor.SetValue(source)


    def OnPrint(self, event):
        self.printer.PrintFile(self.html.GetOpenedPage())
    

#----------------------------------------------------------------------
if __name__ == '__main__':

    class MyFrame(wx.wxFrame):
        """Very standard Frame class. Nothing special here!"""

        def __init__(self):
            wx.wxFrame.__init__(self, wx.NULL, -1, "PyTreeItemData Test", 
                wx.wxDefaultPosition, wx.wxSize(800,500))
            global topFrame
            topFrame = self
            self.split1 = wx.wxSplitterWindow(self, -1)
            self.split2 = wx.wxSplitterWindow(self.split1, -1)
#            win1 = TestListBox(split1, self)
            self.navigator = BuildTreeWidget(self.split1)
            self.viewer = TestHtmlPanel(self.split2, self)

            self.editor = MyEditor(self.split2)
            #self.editor = wxTextCtrl(self, 30, "", wxPoint(0, 0), wxSize(200, 150), wxTE_MULTILINE)

            self.split1.SplitVertically(self.navigator, self.split2, 200)
            self.split2.SplitHorizontally(self.viewer, self.editor, 200)

            menu = wxMenu()
            menu.Append(1001, "Load...")
            menu.Append(1002, "Store...")
            menu.AppendSeparator()
            menu.Append(1003, "Test")
            menu.Append(1004, "About...")
            menu.AppendSeparator()
            menu.Append(1005, "Exit")
            menubar = wxMenuBar()
            menubar.Append(menu, "File")
            menu = wxMenu()
            menu.Append(1090, "About...")
            menubar.Append(menu, "Help")
            self.SetMenuBar(menubar)
            #self.CreateStatusBar(2)
            #EVT_MENU(self, 1001, self.OnMenuEvent)
            #EVT_MENU(self, 1002, self.OnMenuEvent)
            #EVT_MENU(self, 1003, self.OnMenuEvent)
            #EVT_MENU(self, 1004, self.OnMenuEvent)
            #EVT_MENU(self, 1005, self.OnMenuEvent)
            #EVT_MENU(self, 1011, self.OnMenuEvent)
            #EVT_MENU(self, 1080, self.OnMenuEvent)
            #EVT_MENU(self, 1013, self.OnMenuEvent)
            #EVT_MENU(self, 1090, self.OnHelpAbout)
            #EVT_CHAR(self.wnd, self.OnChar)
            #self.OnGameReset()

        def OnMenuEvent(self, event):
            print "got event", event
    
        def WriteText(self, text):
		print text
        
    class MyApp(wx.wxApp):
        """This class is even less interesting than MyFrame."""

        def OnInit(self):
            #these lines are needed for wxHtmlWindow to handle images
            wxImage_AddHandler(wxJPEGHandler())
            wxImage_AddHandler(wxPNGHandler())
            wxImage_AddHandler(wxGIFHandler())

            """OnInit. Boring, boring, boring!"""
            frame = MyFrame()
            frame.Show(wx.TRUE)
            self.SetTopWindow(frame)
            return wx.TRUE

    app = MyApp(0)
    app.MainLoop()



